/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "int.h"
#include "port.h"
#include "timer.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/

unsigned int suji_100;
unsigned int suji_10;
unsigned int suji_1;

unsigned int t_count;
unsigned int k_count;
unsigned char t_flg;

unsigned char in_p;

unsigned char	led_data[11]=
			{0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x27,0x7f,0x6f,0x00};



void	led_port_clear(void)
{
	P4.0=0;
	P4.1=0;
	P4.2=0;
}

void	time_wait(long time)
{
	while(time!=0){
	time--;
	}
}

void	led_7seg_out(int data)
{
	P2=(P2|0x0f)&(~(led_data[data]&0x0f));
	P12=(P12|0x0e)&(~(led_data[data]&0x70)>>3);
	P13.0=1;
}

void	led_disp(void)
{
	led_port_clear();
	led_7seg_out(suji_100);
	P4.0=1;
	time_wait(300);
	led_port_clear();
	led_7seg_out(suji_10);
	P4.1=1;
	time_wait(300);
	led_port_clear();
	led_7seg_out(suji_1);
	P13.0=in_p;
	P4.2=1;
	time_wait(300);
	led_port_clear();
}



void main( void )
{
	/* TODO. add user code */
	
	suji_100=0;
	suji_10=0;
	suji_1=0;
	t_flg=0;
	in_p=1;
	
	TM00_Start();
	while(1){
		led_disp();
		if((P3.0==1)&(t_flg==0)){
			TM00_Stop();
			k_count=60000/t_count;
			TM00_Start();
			suji_100=k_count/100;
			suji_10=(k_count-suji_100*100)/10;
			suji_1=(k_count-suji_100*100-suji_10*10);
			t_count=0;
			t_flg=1;
			if(suji_100>9){suji_100=0;}
			if(suji_10>9){suji_10=0;}
			if(suji_1>9){suji_1=0;}
			if(suji_100==0){suji_100=10;}
		}
		else{
			if((P3.0==0)&(t_flg==1)){
				time_wait(300);
				if(P3.0==0){
					t_flg=0;
				}
			}
		}
		if(P3.0==1){
			in_p=0;
		}
		else{
			in_p=1;
		}
	}
}

